/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreGroup.TCoreGroupPath;
import de.ship.db.tables.TCoreGroupprivilege.TCoreGroupprivilegePath;
import de.ship.db.tables.TCorePerson.TCorePersonPath;
import de.ship.db.tables.TCoreUserprivilege.TCoreUserprivilegePath;
import de.ship.db.tables.records.TCorePrivilegeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCorePrivilege extends TableImpl<TCorePrivilegeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_privilege</code>
     */
    public static final TCorePrivilege T_CORE_PRIVILEGE = new TCorePrivilege();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCorePrivilegeRecord> getRecordType() {
        return TCorePrivilegeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_privilege.lastchange</code>.
     */
    public final TableField<TCorePrivilegeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_privilege.pk</code>.
     */
    public final TableField<TCorePrivilegeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_privilege.name</code>.
     */
    public final TableField<TCorePrivilegeRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    private TCorePrivilege(Name alias, Table<TCorePrivilegeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCorePrivilege(Name alias, Table<TCorePrivilegeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_privilege</code> table reference
     */
    public TCorePrivilege(String alias) {
        this(DSL.name(alias), T_CORE_PRIVILEGE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_privilege</code> table reference
     */
    public TCorePrivilege(Name alias) {
        this(alias, T_CORE_PRIVILEGE);
    }

    /**
     * Create a <code>common_dd.t_core_privilege</code> table reference
     */
    public TCorePrivilege() {
        this(DSL.name("t_core_privilege"), null);
    }

    public <O extends Record> TCorePrivilege(Table<O> path, ForeignKey<O, TCorePrivilegeRecord> childPath, InverseForeignKey<O, TCorePrivilegeRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_PRIVILEGE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCorePrivilegePath extends TCorePrivilege implements Path<TCorePrivilegeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCorePrivilegePath(Table<O> path, ForeignKey<O, TCorePrivilegeRecord> childPath, InverseForeignKey<O, TCorePrivilegeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCorePrivilegePath(Name alias, Table<TCorePrivilegeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCorePrivilegePath as(String alias) {
            return new TCorePrivilegePath(DSL.name(alias), this);
        }

        @Override
        public TCorePrivilegePath as(Name alias) {
            return new TCorePrivilegePath(alias, this);
        }

        @Override
        public TCorePrivilegePath as(Table<?> alias) {
            return new TCorePrivilegePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCorePrivilegeRecord, Integer> getIdentity() {
        return (Identity<TCorePrivilegeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCorePrivilegeRecord> getPrimaryKey() {
        return Keys.PK_CORE_PRIVILEGE;
    }

    @Override
    public List<UniqueKey<TCorePrivilegeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_PRIVILEGE_NAME);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, null, Keys.T_CORE_ELEMENT_HIERARCHY__FK_PRIVILEGE.getInverseKey());

        return _tCoreElementHierarchy;
    }

    private transient TCoreGroupprivilegePath _tCoreGroupprivilege;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_groupprivilege</code> table
     */
    public TCoreGroupprivilegePath tCoreGroupprivilege() {
        if (_tCoreGroupprivilege == null)
            _tCoreGroupprivilege = new TCoreGroupprivilegePath(this, null, Keys.T_CORE_GROUPPRIVILEGE__FK_CORE_GROUPPRIVILEGE_PRIVILEGE.getInverseKey());

        return _tCoreGroupprivilege;
    }

    private transient TCoreUserprivilegePath _tCoreUserprivilege;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_userprivilege</code> table
     */
    public TCoreUserprivilegePath tCoreUserprivilege() {
        if (_tCoreUserprivilege == null)
            _tCoreUserprivilege = new TCoreUserprivilegePath(this, null, Keys.T_CORE_USERPRIVILEGE__FK_CORE_USERPRIVILEGE_PRIVILEGE.getInverseKey());

        return _tCoreUserprivilege;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_group</code> table
     */
    public TCoreGroupPath tCoreGroup() {
        return tCoreGroupprivilege().tCoreGroup();
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_person</code> table
     */
    public TCorePersonPath tCorePerson() {
        return tCoreUserprivilege().tCorePerson();
    }

    @Override
    public TCorePrivilege as(String alias) {
        return new TCorePrivilege(DSL.name(alias), this);
    }

    @Override
    public TCorePrivilege as(Name alias) {
        return new TCorePrivilege(alias, this);
    }

    @Override
    public TCorePrivilege as(Table<?> alias) {
        return new TCorePrivilege(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePrivilege rename(String name) {
        return new TCorePrivilege(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePrivilege rename(Name name) {
        return new TCorePrivilege(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePrivilege rename(Table<?> name) {
        return new TCorePrivilege(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePrivilege where(Condition condition) {
        return new TCorePrivilege(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePrivilege where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePrivilege where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePrivilege where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePrivilege where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePrivilege where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePrivilege where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePrivilege where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePrivilege whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePrivilege whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
